    function varargout = locateSingleFrameEvents(sections)
      %sections = mol.separateOutSections(mol.kmeansData.signalInTermsOfClusterNumber);
      singleFrameRowNums = zeros(length(sections),1);
      for i = 2:length(sections) %first section is nan rows
        if length(sections{i}) == 1
          singleFrameRowNums(i) = sections{i};
        end
      end
      if all(singleFrameRowNums == 0)
        switch nargout
          case 2
            varargout{1} = [];
            varargout{2} = [];
          case 1
            varargout{1} = [];
          otherwise
            error('Output must be either 1 or two variables');
        end
        return;
      else
        singleFrameRowNums = nonzeros(singleFrameRowNums);
      end
      %find which ones are consecutive
      singleFrameRowNums = sort(singleFrameRowNums);
      consecutiveSingleFrames = zeros(size(singleFrameRowNums));
      i = 1; idx = 1;
      while i < length(singleFrameRowNums)
        if singleFrameRowNums(i)+1 == singleFrameRowNums(i+1)
          consecutiveSingleFrames(i) = singleFrameRowNums(i);
          idx = idx + 1;
          consecutiveSingleFrames(i+1) = singleFrameRowNums(i+1);
          idx = idx + 1;
        end
        i = i+1;
      end
      consecutiveSingleFrames = nonzeros(consecutiveSingleFrames);
      TF = ismember(singleFrameRowNums,consecutiveSingleFrames);
      singleFrameRowNums(TF) = [];

      switch nargout
        case 2
          varargout{2} = consecutiveSingleFrames;
          varargout{1} = singleFrameRowNums;
        case 1
          varargout{1} = [consecutiveSingleFrames; singleFrameRowNums];
        otherwise
          error('Output must be either 1 or two variables');
      end
    end