    function sections = separateOutSections(clusteredSignal)
    %returns an n x 1 cell array. where n is the number of unique sections.
    %
    %sections{1,1} is a cell containing row numbers of all nan values
    %sections{n,1} is a cell containing row numbers of all data points that
    %belong to a unique cluster. 
    %all other entries are framenumbers of each section.
    % they are not in order
      [nanRows, ~] = find(isnan(clusteredSignal));
      sections = cell.empty;
      sections{1} = nanRows;
      [nonNanRows,~] = find(~isnan(clusteredSignal));
      clusterNums = unique(clusteredSignal(nonNanRows));
      sectionsIndex = 2;
      i = 1;
      while i <= length(clusterNums)
        [rowsThisCluster,~] = find(clusteredSignal == clusterNums(i));
        if length(rowsThisCluster) == 1
          sections{sectionsIndex} = rowsThisCluster;
          sectionsIndex = sectionsIndex + 1;
          i = i+1;
        else
          idx = 1; sectionStart = rowsThisCluster(1);
          while idx < length(rowsThisCluster)
            if rowsThisCluster(idx+1) == rowsThisCluster(idx) + 1
              idx = idx + 1;
             
            else
              sections{sectionsIndex} = sectionStart:rowsThisCluster(idx);
              sectionsIndex = sectionsIndex + 1;
              sectionStart = rowsThisCluster(idx+1);
              idx = idx + 1;
              
            end
          end
        end
        i = i+1;
      end
      sections = sections';
    end