function clickAndDragRectangle(app, event, ax)
%cp = [ax.CurrentPoint(1,1),ax.CurrentPoint(1,2)];
%beginDrawingFromPoint(ax.UserData.rectangle,cp);
pos = ax.UserData.rectangle.Position;%[xmin, ymin, width, height]. xmin and ymin specify the location of the upper left corner of the rectangle.
switch app.xaxisunitsDropDown.Value
  case 'Frames'
    shortHand = 'frames';
    rate = 1;
  case 'seconds'
    shortHand = 's';
    rate = app.FrameratemsEditField.Value/1000;
  case 'miliseconds'
    shortHand = 'ms';
    rate = app.FrameratemsEditField.Value;
end
xmin = floor(pos(1)/rate);
xmax = xmin + ceil(pos(3)/rate);
ax.UserData.selectedSection = [floor(pos(1)), ceil(pos(3))];
data = app.moleculeArray(app.moleculeNumber).currentData;
xmax = min(xmax, app.moleculeArray(app.moleculeNumber).numFrames);
xmin = max(xmin, 1);
index = xmin:xmax;

dataNames = {'donor', 'acceptor', 'fret'};
moreText = cell.empty;
moreText{1} = app.InfoTextArea.Value{1};
moreText{2} = ['  '];
%moreText{3} = ['Section: [', num2str(floor(pos(1))), ', ',num2str(floor(pos(1))+ceil(pos(3))),'], Length: ', num2str(ceil(pos(3))), shortHand];
moreText{3} = ['Section: [', num2str(xmin), ', ',num2str(xmax),'], Length: ', num2str(length(xmin:xmax)), shortHand];
for i = 1:3
  moreText{end+1} = upper(dataNames{i});%#ok
  dataThisSection = data.(dataNames{i})(xmin:xmax);
  dataThisSection = dataThisSection(~isnan(dataThisSection));
  moreText{end+1} = ['min: ', num2str(min(dataThisSection), '%4.2f'), '  max: ', num2str(max(dataThisSection), '%4.2f')];%#ok
  moreText{end+1} = ['mean: ', num2str(mean(dataThisSection), '%4.2f'), '  median: ', num2str(median(dataThisSection), '%4.2f')];%#ok
  
end
app.MolStatsTextArea.Value = moreText;
drawnow;


end