    function initialCenters = initializeCenters(k, whichData, dataMatrix)
      % remove 'nan' points
      dataMatrix = dataMatrix(~isnan(dataMatrix(:,1)),:);
      switch whichData
        case {'Fret', 'Donor', 'Acceptor'}
          % get data points and then clear the data matrix
          dataPoints = dataMatrix(:,1);
          fretPoints = dataMatrix(:,2);
          data = dataMatrix(:,1);
          clear dataMatrix
          %%% sort data and remove duplicate points
          %dataPoints = unique(dataPoints);
%           [~, ia, ~] = unique(dataPoints);
        [~, ia] = sort(fretPoints);
          sortedFret = fretPoints(ia);
          data = data(ia);
          

          %dataPoints = sort(dataPoints);
          % return numpoints and initial centers fcn, and clear dataPoints
          %npoints = length(dataPoints);
          initialCentersFcn = @(randomIdxNum,data) data(randomIdxNum);
          clear dataPoints  %they are still stored in the function above
        case {'Donor & Acceptor', 'All Three'}
          % use the sum as the sorting data
          %dataPoints = dataMatrix(:,1) + dataMatrix(:,2);
          % or use fret
          dataPoints = dataMatrix(:,3);
          %%% sort data and remove duplicate points
%           [~, ia, ~] = unique(dataPoints);
          [~, ia] = sort(dataPoints);
          clear dataPoints
          % sort original data using index from sorted data
          donorData = dataMatrix(ia,1);
          acceptorData = dataMatrix(ia,2);
          sortedFret = dataMatrix(ia,3);
          data = dataMatrix(ia, 1:3);
          clear dataMatrix ia
          npoints = length(acceptorData);
          % make function handle to use below
          switch whichData
            case 'All Three'
              initialCentersFcn = @(randomIdxNum,data) [data(randomIdxNum,1), data(randomIdxNum,2), data(randomIdxNum,3)];
            otherwise
          initialCentersFcn = @(randomIdxNum,data) [data(randomIdxNum,1), data(randomIdxNum,2)];
          clear donorData acceptorData  %they are still stored in the function above
          end
      end
      lowFretIdxEnd = find(sortedFret <= -1.5,1,'last');
      if isempty(lowFretIdxEnd)
        lowFretIdxEnd = 1;
      else
        lowFretIdxEnd = lowFretIdxEnd +1;
      end
      highFretIdxStart = find(sortedFret > 1.5, 1);
      if isempty(highFretIdxStart)
        highFretIdxStart = length(sortedFret);
      else
        highFretIdxStart = highFretIdxStart -1;
      end
      sortedFretWithoutExtremeValues = sortedFret(lowFretIdxEnd:highFretIdxStart);
      sortedDataWithoutExtremeValues = data(lowFretIdxEnd:highFretIdxStart, :);
%       w = [~isempty(lowFretIdxEnd), ~isempty(highFretIdxStart)];
%       idxStart = 1; idxEnd = npoints; kStart = 1; kEnd = k;
%       if any(w)
%         if ~isempty(lowFretIdxEnd)
%           idxStart = lowFretIdxEnd+1;
%         end
%         if ~isempty(highFretIdxStart)
%           idxEnd = highFretIdxStart-1;
%         end
%       end
%       if k ~= 2 && any(w)
%         if all(w == true)
%           firstInterval = [1,idxStart];
%           lastInterval = [(idxEnd+1), npoints];
%           npoints = length(idxStart:idxEnd);
%           kStart = 2; kEnd = k-1;
%         elseif w(1) == true
%           firstInterval = [1,idxStart];
%           npoints = npoints - length(1:idxStart);
%           kStart = 2;
%         elseif w(2) == true
%           lastInterval = [(idxEnd+1), npoints];
%           npoints = npoints - length((idxEnd+1):npoints);
%           kEnd = k-1;
%         end
%       elseif any(w) && ~all(w)
%         if w(1) == true
%           firstInterval = [1,idxStart];
%           npoints = npoints - length(1:idxStart);
%           kStart = 2;
%         elseif w(2) == true
%           lastInterval = [(idxEnd+1), npoints];
%           npoints = npoints - length((idxEnd+1):npoints);
%           kEnd = k-1;
%         end
%       else
%         idxStart = 1;
%       end
      % divide the data into k sections and pick a random point from each
      % section to be a starting center
      npoints = length(sortedDataWithoutExtremeValues);
      
      lengthOfSection = floor(npoints/k);
            for j = 1:k
        intervalFromWhichToChooseCenter = [(1+lengthOfSection*(j-1)), lengthOfSection*j];
        indexChosenInInterval = randi(intervalFromWhichToChooseCenter, 1, 1);
        fieldName = "centers" + num2str(j);
        initialCenters.(fieldName) = initialCentersFcn(indexChosenInInterval, sortedDataWithoutExtremeValues);
      end
%       for j = kStart:kEnd
%         intervalFromWhichToChooseCenter = [(idxStart+lengthOfSection*(j-1)), lengthOfSection*j];
%         indexChosenInInterval = randi(intervalFromWhichToChooseCenter, 1, 1);
%         fieldName = "centers" + num2str(j);
%         initialCenters.(fieldName) = initialCentersFcn(indexChosenInInterval);
%       end
%       if kStart ~=1
%         indexChosenInInterval = randi(firstInterval, 1, 1);
%         initialCenters.centers1 = initialCentersFcn(indexChosenInInterval);
%       end
%       if kEnd ~= k
%         indexChosenInInterval = randi(lastInterval, 1, 1);
%         fieldName = "centers" + num2str(k);
%         initialCenters.(fieldName) = initialCentersFcn(indexChosenInInterval);
%       end
    end