function [data, numDataPoints] = loadIgorFileData(filenames)
numFiles = size(filenames,2);
data = struct('donor', {}, 'acceptor', {}, 'fret', {}, 'traceNum', {}, 'traceName', {});
numDataPoints = 0;
opt = detectImportOptions(filenames{1}, 'filetype', 'text', 'MissingRule', 'omitrow');
for i = 1:numFiles
  fname = filenames{i};
  t = readtable(fname, opt);
  donor = table2array(t(:,"Var1"));
  acceptor = table2array(t(:,"Var2"));
  fret = acceptor./(acceptor + donor);
  [q, ~] = find(fret == inf | isnan(fret));
  if ~isempty(q)
    fret(q) = 0;
  end
  idx = size(data,2) + 1;
  data(idx).donor = donor;
  data(idx).acceptor = acceptor;
  data(idx).fret = fret;
  data(idx).traceNum = i;
  data(idx).traceName = fname;
  
  numDataPoints = numDataPoints + length(data(idx).donor);
end
end