function [data, numDataPoints] = loadKinSoftChallengeData(filenames)
%challenge sets are saved as .txt files
%one file per molecule
numFiles = size(filenames,2); %filenames should be a cell with char names
opt = detectImportOptions(filenames{1}, 'filetype', 'text');
data = struct('donor', {}, 'acceptor', {}, 'fret', {}, 'traceNum', {}, 'traceName', {});
numDataPoints = 0;
for i = 1:numFiles
  idx = size(data,2) + 1;
  fname = filenames{i};
  t = readtable(fname, opt);
  data(idx).donor = table2array(t(:,2));
  data(idx).acceptor = table2array(t(:,3));
  data(idx).fret = (data(idx).acceptor)./(data(idx).acceptor + data(idx).donor);
  data(idx).traceNum = i;
  data(idx).traceName = fname;
  numDataPoints = numDataPoints + length(data(idx).donor);
end

end
    
