function [data, numDataPoints] = loadPengningsPreSelectedData(traceIdNumbers)
numFiles = size(traceIdNumbers,1);
data = struct('donor', {}, 'acceptor', {}, 'fret', {}, 'traceNum', {}, 'traceName', {});
numDataPoints = 0;
for i = 1:numFiles
  traceId = traceIdNumbers{i};
  fileName = ['cascade', traceId(1:2), 'trace', traceId(3:5), '.txt'];
  t = importdata(fileName);
  badDataRows = t.data(:,9);
  badDataRows = logical(badDataRows);
  dataNames = {'donor', 'acceptor', 'fret'};
  colNumbers = [1, 2, 5];
  for n = 1:3
    d = t.data(:,colNumbers(n));
    d(badDataRows) = nan;
    data(i).(dataNames{n}) = d;
  end
  numDataPoints = numDataPoints + length(data(i).donor);
  data(i).traceNum = str2double(traceId(3:5));
  data(i).traceName = fileName;
end
end