% Make/N=100/O center1_Hist;DelayUpdate
% •Histogram/C/B={0,0.03,100} center1,center1_Hist;DelayUpdate
% •Display center1_Hist
function makeTextFileOfIgorHistogramCommands(fullFileSaveName, dataName, centers, nSections, frameRate, binWidth)
fid = fopen(fullFileSaveName, 'w');
fprintf(fid, '%s\n\n\n', 'Histogram Igor Commands');
k = length(centers);
for i = 1:k
  waveName = ['center', num2str(i)];
  histName = [waveName, '_Hist'];
  fprintf(fid, '%s\n', ['Make/N=60/O ', histName, ';DelayUpdate']);
  fprintf(fid, '%s\n', ['Histogram/C/B={0,', num2str(binWidth), ',100} ', waveName, ',', histName, ';DelayUpdate']);
  fprintf(fid, '%s\n', ['Display ', histName]);
  fprintf(fid, '%s\n', 'Label left "\\Z14Count";DelayUpdate');
  fprintf(fid, '%s\n', 'Label bottom "\\Z14Seconds"');
  fprintf(fid, '%s\n', ['CurveFit/NTHR=0/TBOX=895 exp  ', histName, ' /D']);
  fprintf(fid, '%s\n', ['TextBox/C/N=text0/F=0/A=MT/X=0.00/Y=0.00/E "\\Z14\\f05', dataName, ...
    ' Dwell Times: FRET Efficiency ', num2str(centers(i)), '\r\\Z12\\f07\\JC\\f02', 'time resolution = ',...
    num2str(frameRate), 'ms  n = ', num2str(nSections(i)), '"']);
  
  % to automatically save the graph - but window pops up for it
  %fprintf(fid, '%s\n','SavePICT/E=-6/B=288/I/W=(0,0,6.35,4.5)');
  fprintf(fid, '%s\n\n', ' ');
end
fclose(fid);
end
