    function stitchedDataMatrix = stitchData2(moleculeArray, molNumbers, totalNumFrames, dataNames)
    dataNames{end+1} = 'fret';
    numDataColumns = size(dataNames,2);
    numColumns = numDataColumns + 2; %extra 2 for mol number and trace file number
    stitchedDataMatrix = nan(totalNumFrames, numColumns);
    numMols = size(molNumbers,2);
    i = 1; idx = 1;
    while i <= numMols
      m = molNumbers(i);
      nFrames = moleculeArray(m).numFrames;
      idxEnd = idx + nFrames -1;
      for c = 1:numDataColumns
        stitchedDataMatrix(idx:idxEnd, c) = moleculeArray(m).currentData.(dataNames{c});
      end
      stitchedDataMatrix(idx:idxEnd,(numDataColumns+1)) = ones(nFrames,1)*moleculeArray(m).moleculeNumber;
      stitchedDataMatrix(idx:idxEnd,(numDataColumns+2)) = ones(nFrames,1)*moleculeArray(m).traceNum;
      idx = idxEnd + 1;
      i = i+1;
    end
    end